# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from apifff.api_client import ApiClient


class CdgApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_cdg_collection(self, **kwargs):  # noqa: E501
        """Retrieves the collection of Cdg resources.  # noqa: E501

        Retrieves the collection of Cdg resources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cdg_collection(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cg_typ:
        :param list[str] cg_typ:
        :param str cg_cp:
        :param list[str] cg_cp:
        :param int cg_no_supp:
        :param list[int] cg_no_supp:
        :param str cp_cod:
        :return: InlineResponse2005
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cdg_collection_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_cdg_collection_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_cdg_collection_with_http_info(self, **kwargs):  # noqa: E501
        """Retrieves the collection of Cdg resources.  # noqa: E501

        Retrieves the collection of Cdg resources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cdg_collection_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cg_typ:
        :param list[str] cg_typ:
        :param str cg_cp:
        :param list[str] cg_cp:
        :param int cg_no_supp:
        :param list[int] cg_no_supp:
        :param str cp_cod:
        :return: InlineResponse2005
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cg_typ', 'cg_typ', 'cg_cp', 'cg_cp', 'cg_no_supp', 'cg_no_supp', 'cp_cod']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cdg_collection" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'cg_typ' in params:
            query_params.append(('cg_typ', params['cg_typ']))  # noqa: E501
        if 'cg_typ' in params:
            query_params.append(('cg_typ[]', params['cg_typ']))  # noqa: E501
            collection_formats['cg_typ[]'] = 'multi'  # noqa: E501
        if 'cg_cp' in params:
            query_params.append(('cg_cp', params['cg_cp']))  # noqa: E501
        if 'cg_cp' in params:
            query_params.append(('cg_cp[]', params['cg_cp']))  # noqa: E501
            collection_formats['cg_cp[]'] = 'multi'  # noqa: E501
        if 'cg_no_supp' in params:
            query_params.append(('cg_no_supp', params['cg_no_supp']))  # noqa: E501
        if 'cg_no_supp' in params:
            query_params.append(('cg_no_supp[]', params['cg_no_supp']))  # noqa: E501
            collection_formats['cg_no_supp[]'] = 'multi'  # noqa: E501
        if 'cp_cod' in params:
            query_params.append(('cpCod', params['cp_cod']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/cdgs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2005',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cdg_item(self, cg_no, **kwargs):  # noqa: E501
        """Retrieves a Cdg resource.  # noqa: E501

        Retrieves a Cdg resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cdg_item(cg_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cg_no: Resource identifier (required)
        :return: CdgJsonldCdg
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cdg_item_with_http_info(cg_no, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cdg_item_with_http_info(cg_no, **kwargs)  # noqa: E501
            return data

    def get_cdg_item_with_http_info(self, cg_no, **kwargs):  # noqa: E501
        """Retrieves a Cdg resource.  # noqa: E501

        Retrieves a Cdg resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cdg_item_with_http_info(cg_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cg_no: Resource identifier (required)
        :return: CdgJsonldCdg
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cg_no']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cdg_item" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cg_no' is set
        if ('cg_no' not in params or
                params['cg_no'] is None):
            raise ValueError("Missing the required parameter `cg_no` when calling `get_cdg_item`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cg_no' in params:
            path_params['cgNo'] = params['cg_no']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/cdgs/{cgNo}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CdgJsonldCdg',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
